/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/
package jp.co.ntt.lms.installer.lms;

import java.io.File;
import java.util.Properties;
import java.util.logging.Logger;

import jp.co.ntt.lms.installer.core.InstallerAction;
import jp.co.ntt.lms.installer.core.InstallerActionValue;
import jp.co.ntt.lms.installer.core.InstallerException;
import jp.co.ntt.lms.installer.core.InstallerValues;
import jp.co.ntt.lms.installer.core.util.InstallerCheckUtil;
import jp.co.ntt.lms.installer.core.util.InstallerPropertiesUtil;
import jp.co.ntt.lms.installer.core.util.InstallerUiUtil;
import jp.co.ntt.lms.installer.util.FileUtil;
import jp.co.ntt.lms.installer.util.LoggerUtil;

/**
 * マネージャ設定ファイルの書換項目について入力を求めるアクションクラス。
 * @author T.Nishiki
 */
public class ManagerInputAction implements InstallerAction {
	/**
	 * ログ出力オブジェクト。
	 */
	private static Logger _logger;

	/**
	 * スタティック・イニシャライザ。
	 */
	static {
		_logger = LoggerUtil.getLogger(ManagerInputAction.class);
	}

	/**
	 * アクションをスキップするか判定します。<br>
	 * スキップしないのでfalseを戻します。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return falseを戻します。
	 */
	public boolean isSkipped(InstallerValues values) {
		return false;
	}

	/**
	 * マネージャ設定ファイルの書換項目について入力・確認を求めます。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return ManagerInputValueを戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 * @see ManagerInputValue
	 */
	public InstallerActionValue action(InstallerValues values)
		throws InstallerException {
		////////////////////////////////////////////////////////////////////////
		// メソッド開始ログ
		LoggerUtil.methodHead(_logger, "action(InstallerValues)");
		// 今回入力データ
		ManagerInputValue inputValue = null;
		try {
			// 既存入力データ（デフォルトデータとして使用）
			ManagerInputValue defaultValue = getDefaultValue(values);
			// タイトルの表示
			InstallerUiUtil.outputMessageAsTitle(
				values, "ManagerInputAction.welcome");

			while (true) {
				// 入力実行
				inputValue = readInputValue(values, defaultValue);
				// 入力確認
				if (confirmInputValue(values, inputValue) == true) {
					// 入力確認が済んだら、
					// データベース関連の情報を共通データとして登録
					values.setDbCategory(inputValue.getDbCategory());
					break;
				}
			}
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}
		////////////////////////////////////////////////////////////////////////
		// メソッド終了ログ
		LoggerUtil.methodTail(_logger, "action(InstallerValues)", inputValue);
		return inputValue;
	}

	/**
	 * マネージャ設定ファイルの書換項目について入力を求めます。<br>
	 *
	 * @param values インストーラ共通データ・オブジェクト。
	 * @param defaultValue デフォルト値。
	 * @return 入力された内容をManagerInputValueを戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 */
	private ManagerInputValue readInputValue(
			InstallerValues values, ManagerInputValue defaultValue)
			throws InstallerException {
		LoggerUtil.methodHead(_logger,
			"readInputValue(InstallerValues," + defaultValue + ")");

		ManagerInputValue inputValue = null;
		try {
			inputValue = new ManagerInputValue();
			// =================================================================
			// ホスト名
			String hostName = null;
			while (true) {
				hostName = InstallerUiUtil.askUserInput(values,
						"ManagerInputAction.prompt.hostName",
						defaultValue.getHostName());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(hostName, values,
						"ManagerInputAction.error.hostName.empty")) {
					continue;
				}
				break;
			}
			inputValue.setHostName(hostName);
			// =================================================================
			// ＬＯホスト名
			String loHostName = null;
			while (true) {
				loHostName = InstallerUiUtil.askUserInput(values,
						"ManagerInputAction.prompt.loHostName",
						defaultValue.getLoHostName());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(loHostName, values,
						"ManagerInputAction.error.loHostName.empty")) {
					continue;
				}
				break;
			}
			inputValue.setLoHostName(loHostName);
			// =================================================================
			// ＲＤＢＭＳの種類選択
			String dbCategory = null;
			while (true) {
				dbCategory = InstallerUiUtil.askUserInput(values,
					"ManagerInputAction.prompt.dbCategory",
					defaultValue.getDbCategory());
				// 対象外の入力
				boolean violate = InstallerCheckUtil.isPatternViolation(
					dbCategory, "[0-2]", values,
					"ManagerInputAction.error.dbCategory.format");
				if (violate) {
					continue;
				}
				break;
			}
			inputValue.setDbCategory(dbCategory);
			// =================================================================
			// データベースのホスト名
			String dbHost = null;
			while (true) {
				dbHost = InstallerUiUtil.askUserInput(values,
						"ManagerInputAction.prompt.dbHost",
						defaultValue.getDbHost());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(dbHost, values,
						"ManagerInputAction.error.dbHost.empty")) {
					continue;
				}
				break;
			}
			inputValue.setDbHost(dbHost);
			// =================================================================
			// データベース接続のユーザ名
			String dbUser = null;
			while (true) {
				dbUser = InstallerUiUtil.askUserInput(values,
						"ManagerInputAction.prompt.dbUser",
						defaultValue.getDbUser());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(dbUser, values,
						"ManagerInputAction.error.dbUser.empty")) {
					continue;
				}
				break;
			}
			inputValue.setDbUser(dbUser);
			// =================================================================
			// データベース接続のパスワード
			String dbPassword = null;
			dbPassword = InstallerUiUtil.askUserInput(values,
					"ManagerInputAction.prompt.dbPassword",
					defaultValue.getDbPassword());
			inputValue.setDbPassword(dbPassword);
			// =================================================================
			// データベースのポート番号
			String dbPort = null;
			while (true) {
				dbPort = InstallerUiUtil.askUserInput(values,
						"ManagerInputAction.prompt.dbPort",
						defaultValue.getDbPort());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(dbPort, values,
						"ManagerInputAction.error.dbPort.empty")) {
					continue;
				}
				break;
			}
			inputValue.setDbPort(dbPort);
			// =================================================================
			// データベース名
			String dbName = null;
			while (true) {
				dbName = InstallerUiUtil.askUserInput(values,
						"ManagerInputAction.prompt.dbName",
						defaultValue.getDbName());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(dbName, values,
						"ManagerInputAction.error.dbName.empty")) {
					continue;
				}
				break;
			}
			inputValue.setDbName(dbName);
			// =================================================================
			// データベース・エンコード
			String dbEncode = null;
			while (true) {
				dbEncode = InstallerUiUtil.askUserInput(values,
						"ManagerInputAction.prompt.dbEncode",
						defaultValue.getDbEncode());
				// 未入力
				if (InstallerCheckUtil.isEmptyViolation(dbEncode, values,
						"ManagerInputAction.error.dbEncode.empty")) {
					continue;
				}
				break;
			}
			inputValue.setDbEncode(dbEncode);
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger,
			"readInputValue(InstallerValues,ManagerInputValue)", inputValue);
		return inputValue;
	}

	/**
	 * 入力した内容を表示し、ユーザに確認を求めます。<br>
	 * @param values インストーラ共通データ・オブジェクト。
	 * @param inputValue 入力された内容
	 * @return 入力された内容にユーザ確認がとれた場合true、
	 *          とれなかった場合falseを戻します。
	 * @throws InstallerException 処理中にエラーが発生した場合。
	 */
	private boolean confirmInputValue(
			InstallerValues values, ManagerInputValue inputValue)
			throws InstallerException {

		LoggerUtil.methodHead(_logger,
			"confirmInputValue(InstallerValues, ManagerInputValue)");
		boolean confirm = false;
		try {
			// =================================================================
			// タイトルを表示
			InstallerUiUtil.outputConfirmTitle(values,
				"ManagerInputAction.confirm.title");
			// =================================================================
			// 入力内容の表示
			// =================================================================
			// ホスト名
			InstallerUiUtil.outputConfirm(values,
				"ManagerInputAction.confirm.hostName",
				inputValue.getHostName());
			// ＬＯホスト名
			InstallerUiUtil.outputConfirm(values,
				"ManagerInputAction.confirm.loHostName",
				inputValue.getLoHostName());
			// データベース種別
			String dbCategoryName = values.getMessage(
				"ManagerInputAction.confirm.dbCategory."
					+ inputValue.getDbCategory());
			InstallerUiUtil.outputConfirm(values,
				"ManagerInputAction.confirm.dbCategory", dbCategoryName);
			// データベース・ホスト名
			InstallerUiUtil.outputConfirm(values,
				"ManagerInputAction.confirm.dbHost",
				inputValue.getDbHost());
			// データベース・ユーザ名
			InstallerUiUtil.outputConfirm(values,
				"ManagerInputAction.confirm.dbUser",
				inputValue.getDbUser());
			// データベース・パスワード
			InstallerUiUtil.outputConfirm(values,
				"ManagerInputAction.confirm.dbPassword",
				inputValue.getDbPassword());
			// データベース・ポート番号
			InstallerUiUtil.outputConfirm(values,
				"ManagerInputAction.confirm.dbPort",
				inputValue.getDbPort());
			// データベース名
			InstallerUiUtil.outputConfirm(values,
				"ManagerInputAction.confirm.dbName",
				inputValue.getDbName());
			// データベース・エンコード
			InstallerUiUtil.outputConfirm(values,
				"ManagerInputAction.confirm.dbEncode",
				inputValue.getDbEncode());
			// =================================================================
			// ユーザ確認
			confirm = InstallerUiUtil.askUserConfirm(
				values, "ManagerInputAction.confirm" );
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}

		LoggerUtil.methodTail(_logger,
			"confirmInputValue(InstallerValues, ManagerInputValue)", confirm);
		return confirm;
	}

	/**
	 * 既存のデータから、入力項目のデフォルト値を取得します。<br>
	 * @param values インストーラ共通データ・オブジェクト。
	 * @return デフォルト値をManagerInputValueの形で戻します。
	 * @throws InstallerException 実行中に例外が発生した場合。
	 */
	private ManagerInputValue getDefaultValue(InstallerValues values)
			throws InstallerException {
		// メソッド開始ログ
		LoggerUtil.methodHead(_logger,
			"getDefaultValue(InstallerValues)");

		ManagerInputValue defaultValue = null;
		try {
			defaultValue = new ManagerInputValue();
			////////////////////////////////////////////////////////////////////
			// プロパティの取得
			// =================================================================
			// 既存の内容
			File existFile = values.getFileOnSystem(
					defaultValue.getTargetFileKey());
			Properties existProperties
				= FileUtil.loadAsProperties(existFile);
			// =================================================================
			// リソース（原本）の内容
			Properties resourceProperties
				= InstallerPropertiesUtil.load(
					values, defaultValue.getTargetFileKey());
			// =================================================================
			// ホスト名
			String hostName = InstallerPropertiesUtil.determineInitialValue(
								existProperties, resourceProperties,
								ManagerInputValue.KEY_HOST_NAME);
			defaultValue.setHostName(hostName);
			// =================================================================
			// LOホスト名
			String loHostName = InstallerPropertiesUtil.determineInitialValue(
								existProperties, resourceProperties,
								ManagerInputValue.KEY_LO_HOST_NAME);
			defaultValue.setLoHostName(loHostName);
			// =================================================================
			// データベース・種別
			String dbCategory = InstallerPropertiesUtil.determineInitialValue(
								existProperties, resourceProperties,
								ManagerInputValue.KEY_DB_CATEGORY);
			defaultValue.setDbCategory(dbCategory);
			// =================================================================
			// データベース・ホスト名
			String dbHost = InstallerPropertiesUtil.determineInitialValue(
								existProperties, resourceProperties,
								ManagerInputValue.KEY_DB_HOST);
			defaultValue.setDbHost(dbHost);
			// =================================================================
			// データベース接続のユーザ名
			String dbUser = InstallerPropertiesUtil.determineInitialValue(
								existProperties, resourceProperties,
								ManagerInputValue.KEY_DB_USER);
			defaultValue.setDbUser(dbUser);
			// =================================================================
			// データベース接続のパスワード
			//String dbPassword = InstallerPropertiesUtil.determineInitialValue(
			//					existProperties, resourceProperties,
			//					ManagerInputValue.KEY_DB_PASS);
			//defaultValue.setDbPassword(dbPassword);
			// =================================================================
			// データベースのポート番号
			String dbPort = InstallerPropertiesUtil.determineInitialValue(
								existProperties, resourceProperties,
								ManagerInputValue.KEY_DB_PORT);
			defaultValue.setDbPort(dbPort);
			// =================================================================
			// データベース名
			String dbName = InstallerPropertiesUtil.determineInitialValue(
								existProperties, resourceProperties,
								ManagerInputValue.KEY_DB_NAME);
			defaultValue.setDbName(dbName);
			// =================================================================
			// データベース・エンコード
			String dbEncode = InstallerPropertiesUtil.determineInitialValue(
								existProperties, resourceProperties,
								ManagerInputValue.KEY_DB_ENCODE);
			defaultValue.setDbEncode(dbEncode);
		}
		catch (InstallerException e) {
			throw e;
		}
		catch (Exception e) {
			LoggerUtil.throwable(_logger, e);
			throw new InstallerException(e);
		}
		// メソッド終了ログ
		LoggerUtil.methodTail(_logger,
			"getDefaultValue(InstallerValues)", defaultValue);
		return defaultValue;
	}
}
